package IncludeTemplateViewer::App::CMS;

use strict;

sub get_include_template {
    my ($cb, $app, $param, $tmpl) = @_;

    my $id = $param->{id};
    if ($id) {
        my $blog_id = $app->blog->id;
        my $name = $param->{name};

        my @list;
        my @included;
        my @tmpl = MT::Template->load( { blog_id => $blog_id, type => { not => 'backup' } } );
        for my $t (@tmpl) {
            if ($t->text =~ /module="$name"|widget="$name"/) {
                push @included, {
                    include_link => $app->mt_uri(
                        mode => 'view',
                        args => {
                            blog_id => $blog_id,
                            '_type' => 'template',
                            id      => $t->id
                        },
                    ),
                    include_module => $t->name,
                };
            }
        }
        $param->{included_loop} = \@included;
    }
}

sub add_include_template {
    my ($cb, $app, $template) = @_;

    my $old = <<HERE;
    <mt:if name="have_includes">
HERE
    $old = quotemeta($old);

    my $label = MT->translate('Include Templates');

    my $new = <<HERE;
<mt:if name="template_group" like="(module|widget)">
    <mtapp:widget
        id="template-includes"
        label="$label">
    <ul>
    <mt:loop name="included_loop">
        <li><a href="<mt:var name="include_link">" class="icon-left icon-related"><mt:var name="include_module"></a></li>
    </mt:loop>
    </ul>
    </mtapp:widget>
</mt:if>
    <mt:if name="have_includes">
HERE
    $$template =~ s/$old/$new/;
}

1;
